Index: src/work/jacint/preflow_push_hl.h
===================================================================
--- src/work/jacint/preflow_push_hl.h	(revision 88)
+++ src/work/jacint/preflow_push_hl.h	(revision 97)
@@ -4,5 +4,7 @@
 by jacint. 
 Runs the highest label variant of the preflow push algorithm with 
-running time O(n^2\sqrt(m)). 
+running time O(n^2\sqrt(m)), and with the 'empty level' heuristic. 
+
+'A' is a parameter for the empty_level heuristic
 
 Member functions:
@@ -16,9 +18,15 @@
 T flowonedge(EdgeIt e) : for a fixed maximum flow x it returns x(e) 
 
-Graph::EdgeMap<T> allflow() : returns the fixed maximum flow x
-
-Graph::NodeMap<bool> mincut() : returns a 
-     characteristic vector of a minimum cut. (An empty level 
-     in the algorithm gives a minimum cut.)
+FlowMap allflow() : returns the fixed maximum flow x
+
+void mincut(CutMap& M) : sets M to the characteristic vector of a 
+     minimum cut. M should be a map of bools initialized to false.
+
+void min_mincut(CutMap& M) : sets M to the characteristic vector of the 
+     minimum min cut. M should be a map of bools initialized to false.
+
+void max_mincut(CutMap& M) : sets M to the characteristic vector of the 
+     maximum min cut. M should be a map of bools initialized to false.
+
 */
 
@@ -30,10 +38,11 @@
 #include <vector>
 #include <stack>
-
-#include <reverse_bfs.h>
+#include <queue>
 
 namespace marci {
 
-  template <typename Graph, typename T>
+  template <typename Graph, typename T, 
+    typename FlowMap=typename Graph::EdgeMap<T>, typename CapMap=typename Graph::EdgeMap<T>, 
+    typename IntMap=typename Graph::NodeMap<int>, typename TMap=typename Graph::NodeMap<T> >
   class preflow_push_hl {
     
@@ -47,36 +56,33 @@
     NodeIt s;
     NodeIt t;
-    typename Graph::EdgeMap<T> flow;
-    typename Graph::EdgeMap<T> capacity; 
+    FlowMap flow;
+    CapMap& capacity;  
     T value;
-    typename Graph::NodeMap<bool> mincutvector;
-
+    
   public:
 
-    preflow_push_hl(Graph& _G, NodeIt _s, NodeIt _t, 
-		    typename Graph::EdgeMap<T>& _capacity) :
-      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity), 
-      mincutvector(_G, true) { }
-
-
-    /*
-      The run() function runs the highest label preflow-push, 
-      running time: O(n^2\sqrt(m))
-    */
+    preflow_push_hl(Graph& _G, NodeIt _s, NodeIt _t, CapMap& _capacity) :
+      G(_G), s(_s), t(_t), flow(_G, 0), capacity(_capacity) { }
+
+
+    
+
     void run() {
  
-      std::cout<<"A is "<<A<<" ";
-
-      typename Graph::NodeMap<int> level(G);      
-      typename Graph::NodeMap<T> excess(G); 
-
       int n=G.nodeNum(); 
       int b=n-2; 
       /*
 	b is a bound on the highest level of an active node. 
-	In the beginning it is at most n-2.
       */
 
-      std::vector<int> numb(n);     //The number of nodes on level i < n.
+      IntMap level(G,n);      
+      TMap excess(G); 
+
+      std::vector<int> numb(n);    
+      /*
+	The number of nodes on level i < n. It is
+	initialized to n+1, because of the reverse_bfs-part.
+      */
+
       std::vector<std::stack<NodeIt> > stack(2*n-1);    
       //Stack of the active nodes in level i.
@@ -84,14 +90,26 @@
 
       /*Reverse_bfs from t, to find the starting level.*/
-      reverse_bfs<Graph> bfs(G, t);
-      bfs.run();
-      for(EachNodeIt v=G.template first<EachNodeIt>(); v.valid(); ++v) 
-	{
-	  int dist=bfs.dist(v);
-	  level.set(v, dist);
-	  ++numb[dist];
-	}
-
+      level.set(t,0);
+      std::queue<NodeIt> bfs_queue;
+      bfs_queue.push(t);
+
+      while (!bfs_queue.empty()) {
+
+	NodeIt v=bfs_queue.front();	
+	bfs_queue.pop();
+	int l=level.get(v)+1;
+
+	for(InEdgeIt e=G.template first<InEdgeIt>(v); e.valid(); ++e) {
+	  NodeIt w=G.tail(e);
+	  if ( level.get(w) == n ) {
+	    bfs_queue.push(w);
+	    ++numb[l];
+	    level.set(w, l);
+	  }
+	}
+      }
+	
       level.set(s,n);
+
 
 
@@ -99,14 +117,13 @@
       for(OutEdgeIt e=G.template first<OutEdgeIt>(s); e.valid(); ++e) 
 	{
-	  if ( capacity.get(e) > 0 ) {
-	    NodeIt w=G.head(e);
-	    if ( w!=s ) {	  
-	      if ( excess.get(w) == 0 && w!=t ) stack[level.get(w)].push(w); 
-	      flow.set(e, capacity.get(e)); 
-	      excess.set(w, excess.get(w)+capacity.get(e));
-	    }
-	  }
-	}
-
+	  if ( capacity.get(e) == 0 ) continue;
+	  NodeIt w=G.head(e);
+	  if ( w!=s ) {	  
+	    if ( excess.get(w) == 0 && w!=t ) stack[level.get(w)].push(w); 
+	    flow.set(e, capacity.get(e)); 
+	    excess.set(w, excess.get(w)+capacity.get(e));
+	  }
+	}
+      
       /* 
 	 End of preprocessing 
@@ -114,138 +131,130 @@
 
 
-
       /*
 	Push/relabel on the highest level active nodes.
       */
-	
       /*While there exists an active node.*/
       while (b) { 
-
-	/*We decrease the bound if there is no active node of level b.*/
-	if (stack[b].empty()) {
+	if ( stack[b].empty() ) { 
 	  --b;
-	} else {
-
-	  NodeIt w=stack[b].top();        //w is a highest label active node.
-	  stack[b].pop();           
-	
-	  int newlevel=2*n-2;             //In newlevel we bound the next level of w.
-	
+	  continue;
+	} 
+	
+	NodeIt w=stack[b].top();        //w is a highest label active node.
+	stack[b].pop();           
+	int lev=level.get(w);
+	int exc=excess.get(w);
+	int newlevel=2*n-2;      //In newlevel we bound the next level of w.
+	
+	//  if ( level.get(w) < n ) { //Nem tudom ez mukodik-e
 	  for(OutEdgeIt e=G.template first<OutEdgeIt>(w); e.valid(); ++e) {
 	    
-	    if ( flow.get(e) < capacity.get(e) ) {              
-	      /*e is an edge of the residual graph */
-
-	      NodeIt v=G.head(e);               /*e is the edge wv.*/
-
-	      if( level.get(w) == level.get(v)+1 ) {      
-		/*Push is allowed now*/
-
-		if ( excess.get(v)==0 && v != s && v !=t ) stack[level.get(v)].push(v); 
-		/*v becomes active.*/
-
-		if ( capacity.get(e)-flow.get(e) > excess.get(w) ) {       
-		  /*A nonsaturating push.*/
-		  
-		  flow.set(e, flow.get(e)+excess.get(w));
-		  excess.set(v, excess.get(v)+excess.get(w));
-		  excess.set(w,0);
-		  break; 
-
-		} else { 
-		  /*A saturating push.*/
-
-		  excess.set(v, excess.get(v)+capacity.get(e)-flow.get(e));
-		  excess.set(w, excess.get(w)-capacity.get(e)+flow.get(e));
-		  flow.set(e, capacity.get(e));
-		  if ( excess.get(w)==0 ) break;
-		  /*If w is not active any more, then we go on to the next node.*/
-		  
-		}
-	      } else {
-		newlevel = newlevel < level.get(v) ? newlevel : level.get(v);
+	    if ( flow.get(e) == capacity.get(e) ) continue; 
+	    NodeIt v=G.head(e);            
+	    //e=wv	    
+	    
+	    if( lev > level.get(v) ) {      
+	      /*Push is allowed now*/
+	      
+	      if ( excess.get(v)==0 && v != s && v !=t ) 
+		stack[level.get(v)].push(v); 
+	      /*v becomes active.*/
+	      
+	      int cap=capacity.get(e);
+	      int flo=flow.get(e);
+	      int remcap=cap-flo;
+	      
+	      if ( remcap >= exc ) {       
+		/*A nonsaturating push.*/
+		
+		flow.set(e, flo+exc);
+		excess.set(v, excess.get(v)+exc);
+		exc=0;
+		break; 
+		
+	      } else { 
+		/*A saturating push.*/
+		
+		flow.set(e, cap );
+		excess.set(v, excess.get(v)+remcap);
+		exc-=remcap;
 	      }
-	    
-	    } //if the out edge wv is in the res graph 
-	 
+	    } else if ( newlevel > level.get(v) ) newlevel = level.get(v);
+	    
 	  } //for out edges wv 
+	
+	
+	if ( exc > 0 ) {	
+	  for( InEdgeIt e=G.template first<InEdgeIt>(w); e.valid(); ++e) {
+	    
+	    if( flow.get(e) == 0 ) continue; 
+	    NodeIt v=G.tail(e);  
+	    //e=vw
+	    
+	    if( lev > level.get(v) ) {  
+	      /*Push is allowed now*/
+	      
+	      if ( excess.get(v)==0 && v != s && v !=t) 
+		stack[level.get(v)].push(v); 
+	      /*v becomes active.*/
+	      
+	      int flo=flow.get(e);
+	      
+	      if ( flo >= exc ) { 
+		/*A nonsaturating push.*/
+		
+		flow.set(e, flo-exc);
+		excess.set(v, excess.get(v)+exc);
+		exc=0;
+		break; 
+	      } else {                                               
+		/*A saturating push.*/
+		
+		excess.set(v, excess.get(v)+flo);
+		exc-=flo;
+		flow.set(e,0);
+	      }  
+	    } else if ( newlevel > level.get(v) ) newlevel = level.get(v);
+	    
+	  } //for in edges vw
 	  
-
-	  if ( excess.get(w) > 0 ) {	
-	    
-	    for( InEdgeIt e=G.template first<InEdgeIt>(w); e.valid(); ++e) {
-	      NodeIt v=G.tail(e);  /*e is the edge vw.*/
-
-	      if( flow.get(e) > 0 ) {             
-		/*e is an edge of the residual graph */
-
-		if( level.get(w)==level.get(v)+1 ) {  
-		  /*Push is allowed now*/
-		
-		  if ( excess.get(v)==0 && v != s && v !=t) stack[level.get(v)].push(v); 
-		  /*v becomes active.*/
-
-		  if ( flow.get(e) > excess.get(w) ) { 
-		    /*A nonsaturating push.*/
-		  
-		    flow.set(e, flow.get(e)-excess.get(w));
-		    excess.set(v, excess.get(v)+excess.get(w));
-		    excess.set(w,0);
-		    break; 
-		  } else {                                               
-		    /*A saturating push.*/
-		    
-		    excess.set(v, excess.get(v)+flow.get(e));
-		    excess.set(w, excess.get(w)-flow.get(e));
-		    flow.set(e,0);
-		    if ( excess.get(w)==0 ) break;
-		  }  
-		} else {
-		  newlevel = newlevel < level.get(v) ? newlevel : level.get(v);
-		}
-		
-	      } //if in edge vw is in the res graph 
-
-	    } //for in edges vw
-
-	  } // if w still has excess after the out edge for cycle
-
-
-	  /*
-	    Relabel
-	  */
+	} // if w still has excess after the out edge for cycle
+	
+	excess.set(w, exc);
+	
+
+	
+
+	/*
+	  Relabel
+	*/
+	
+	if ( exc > 0 ) {
+	  //now 'lev' is the old level of w
+	  level.set(w,++newlevel);
 	  
-	  if ( excess.get(w) > 0 ) {
-	    
-	    int oldlevel=level.get(w);	    
-	    level.set(w,++newlevel);
-
-	    if ( oldlevel < n ) {
-	      --numb[oldlevel];
-
-	      if ( !numb[oldlevel] && oldlevel < A*n ) {  //If the level of w gets empty. 
-		
-		for (EachNodeIt v=G.template first<EachNodeIt>(); v.valid() ; ++v) {
-		  if (level.get(v) > oldlevel && level.get(v) < n ) level.set(v,n);  
-		}
-		for (int i=oldlevel+1 ; i!=n ; ++i) numb[i]=0; 
-		if ( newlevel < n ) newlevel=n; 
-	      } else { 
-		if ( newlevel < n ) ++numb[newlevel]; 
+	  if ( lev < n ) {
+	    --numb[lev];
+	    
+	    if ( !numb[lev] && lev < A*n ) {  //If the level of w gets empty. 
+	      
+	      for (EachNodeIt v=G.template first<EachNodeIt>(); v.valid() ; ++v) {
+		if (level.get(v) > lev && level.get(v) < n ) level.set(v,n);  
 	      }
+	      for (int i=lev+1 ; i!=n ; ++i) numb[i]=0; 
+	      if ( newlevel < n ) newlevel=n; 
 	    } else { 
-	    if ( newlevel < n ) ++numb[newlevel];
+	      if ( newlevel < n ) ++numb[newlevel]; 
 	    }
-	    
-	    stack[newlevel].push(w);
-	    b=newlevel;
-
-	  }
-
-	} // if stack[b] is nonempty
-
+	  } 
+	  
+	  stack[newlevel].push(w);
+	  b=newlevel;
+	  
+	}
+	
       } // while(b)
-
-
+      
+      
       value = excess.get(t);
       /*Max flow value.*/
@@ -272,5 +281,5 @@
     */
 
-    T flowonedge(EdgeIt e) {
+    T flowonedge(const EdgeIt e) {
       return flow.get(e);
     }
@@ -282,5 +291,5 @@
     */
 
-    typename Graph::EdgeMap<T> allflow() {
+    FlowMap allflow() {
       return flow;
     }
@@ -288,40 +297,91 @@
 
 
-    /*
-      Returns a minimum cut by using a reverse bfs from t in the residual graph.
+
+    /*
+      Returns the minimum min cut, by a bfs from s in the residual graph.
     */
     
-    typename Graph::NodeMap<bool> mincut() {
+    template<typename CutMap>
+    void mincut(CutMap& M) {
     
       std::queue<NodeIt> queue;
       
-      mincutvector.set(t,false);      
-      queue.push(t);
+      M.set(s,true);      
+      queue.push(s);
 
       while (!queue.empty()) {
         NodeIt w=queue.front();
 	queue.pop();
+	
+	for(OutEdgeIt e=G.template first<OutEdgeIt>(w) ; e.valid(); ++e) {
+	  NodeIt v=G.head(e);
+	  if (!M.get(v) && flow.get(e) < capacity.get(e) ) {
+	    queue.push(v);
+	    M.set(v, true);
+	  }
+	} 
 
 	for(InEdgeIt e=G.template first<InEdgeIt>(w) ; e.valid(); ++e) {
 	  NodeIt v=G.tail(e);
-	  if (mincutvector.get(v) && flow.get(e) < capacity.get(e) ) {
+	  if (!M.get(v) && flow.get(e) > 0 ) {
 	    queue.push(v);
-	    mincutvector.set(v, false);
-	  }
-	} // for
+	    M.set(v, true);
+	  }
+	}
+
+      }
+    }
+
+
+
+    /*
+      Returns the maximum min cut, by a reverse bfs 
+      from t in the residual graph.
+    */
+    
+    template<typename CutMap>
+    void max_mincut(CutMap& M) {
+    
+      std::queue<NodeIt> queue;
+      
+      M.set(t,true);        
+      queue.push(t);
+
+      while (!queue.empty()) {
+        NodeIt w=queue.front();
+	queue.pop();
+
+	for(InEdgeIt e=G.template first<InEdgeIt>(w) ; e.valid(); ++e) {
+	  NodeIt v=G.tail(e);
+	  if (!M.get(v) && flow.get(e) < capacity.get(e) ) {
+	    queue.push(v);
+	    M.set(v, true);
+	  }
+	}
 
 	for(OutEdgeIt e=G.template first<OutEdgeIt>(w) ; e.valid(); ++e) {
 	  NodeIt v=G.head(e);
-	  if (mincutvector.get(v) && flow.get(e) > 0 ) {
+	  if (!M.get(v) && flow.get(e) > 0 ) {
 	    queue.push(v);
-	    mincutvector.set(v, false);
-	  }
-	} // for
-
+	    M.set(v, true);
+	  }
+	}
       }
 
-      return mincutvector;
-    
-    }
+      for(EachNodeIt v=G.template first<EachNodeIt>() ; v.valid(); ++v) {
+	M.set(v, !M.get(v));
+      }
+
+    }
+
+
+
+    template<typename CutMap>
+    void min_mincut(CutMap& M) {
+      mincut(M);
+    }
+
+
+
   };
 }//namespace marci